{*******************************************************}
{                                                       }
{       Run-time Library for Borland Delphi 5           }
{       Some integsting function for windows            }
{                                                       }
{       Copyright (c)  2001-2002 by Veresov Dmitry      }
{                                                       }
{     *****                                             }
{     **   **                                           }
{     **    **       ************                       }
{     **    **     **     **     **                     }
{     **    **     **     **     **                     }
{     **   **      **     **     **                     }
{     *****        ***    ***    ****                   }
{                                                       }
{*******************************************************}

unit Dm;

interface

uses
  ExtCtrls, imbuttoncont, ShlObj, ComObj, ActiveX, controls, Filectrl, forms, MMSystem, Registry, ShellApi, Windows, SysUtils, Classes, Graphics;

{$EXTERNALSYM SetLayeredWindowAttributes}
  function SetLayeredWindowAttributes(Hwnd: THandle; crKey: COLORREF; bAlpha: Byte; dwFlags: DWORD): Boolean; stdcall;
  function SetLayeredWindowAttributes; external user32 name 'SetLayeredWindowAttributes';
  Function ExtractIcon(hInst : LongInt; lpszExeFileName :String;nIconIndex : LongInt): LongInt;
stdcall; external 'shell32.dll' name 'ExtractIconA';

const
  BufferSize = 3*4*4096;
Type
  PBuffer = ^TBuffer;
  TBuffer = array [1..BufferSize] of Byte;


type
  TCallBack=procedure(Position,Size:Longint) of object; {   }
  TCopyingProgress = procedure(bytes : integer) of object;
  TRGB=record
  b,g,r : byte;
end;

type
   Tcopyfile = class(TObject)
   private
   FNameIn : string;
   FNameOut : string;
   FOnCall : TCallBack;
   Fstop : boolean;
   procedure setoncall(const Value: TCallBack);
   Public
   constructor create; overload;
   Published
   Procedure copy(NameIn, NameOut : string);
   Property OnCall : TCallBack read FOnCall write SetOnCall;
   Property NameIn : string read FNameIn;
   Property Nameout : string read FNameOut;
   Procedure stop;
  end;

Type
    ARGB=array [0..1] of TRGB;
    PARGB=^ARGB;

const
 pwd_rusup='';
 pwd_rusdown='';
 pwd_englup='QWERTYUIOPASDFGHJKLZXCVBNM';
 pwd_engldown='qwertyuiopasdfghjklzxcvbnm';
 pwd_cifr='0123456789';
 pwd_spec='!#$%&()=?@<>|{[]}/\*~+#;:.-_';
 pwd_all=pwd_rusup+pwd_rusdown+pwd_engldown+pwd_englup+pwd_cifr+pwd_spec;
 pwd_norm=pwd_engldown+pwd_englup+pwd_cifr;
 delphi_temp='|scr|exe|dcu|~pas|~dfm|~dpr|cfg|dof|';
 unusedchar : set of char = ['''','/','|','\','<','>','"','?','*',':'];
 unusedchar_folders : set of char = ['''','/','|','<','>','"','?','*',':'];

Const
  WS_EX_LAYERED = $00080000;
  LWA_ALPHA = $00000002;

type //     ScanLine
  TRGBArray = array[Word] of TRGBTriple;
  PRGBArray = ^TRGBArray;

function BitmapToRegion(Bitmap: TBitmap; TransColor: TColor): HRGN;
Function hextointdef(hex:string;default:integer):integer;
function IntPower(Base: Extended; Exponent: Integer): Extended;
function GetCPUSpeed: real;   overload;
function GetCPUSpeed(interval:integer):real;   overload;
function SetFullscreenMode(Width,Height,PixelFormat:integer):Boolean;
procedure RestoreDefaultMode;
function FileCopy(InFile,OutFile: String):boolean;
function dircopy(startcatalog,movecatalog:string):boolean;
procedure SetWallpaper(sWallpaperBMPPath : String; tupe : integer );
function run(exefile:string):boolean;
function runWait(exefile:string):boolean;
procedure keyEng;
procedure KeyRus;
function DriveState(DrvLetter: Char): integer;
procedure openCD;
procedure closeCD;
procedure RunOnStartup(Name:string; path:string; options:integer);
function Autorunexe(disk:string):string;
function Autorunico(disk:string):string;
function icontobit16(icon:Ticon):Tbitmap;
function getdirectory(filename:string):string;
Function getanyCDletter:string;
Function getwinversion:string;
Function getsystemroot:string;
Function getwinowner:string;
Function getorganization:string;
Procedure del_close_btn(handle:Thandle);
Procedure deldir(dir : String; mask : string); forward; overload;
Procedure deldir(dir : String; mask : string; onprogress : TCopyingProgress); forward; overload;
Procedure dontruntwo(name : string);
Function loadiconfromexe( filename : string ; index : Integer): Hicon;
Function getdrivename(driveletter : string):string;
Procedure hidefromTaskBar(handle:Thandle);
procedure hidetray(visi:boolean);
Function GetDriveSerialNo(DriveLetter : string):Dword;
Function strtofloatdef(str : string; default :real):real;
Function getext(Filename : string) : string;
function RandomPwd(PWLen: integer; StrTable : string): string;
function bitmaptoicon(bit : Tbitmap; color : Tcolor):Ticon;
function extinmask(mask : string; ext : string):boolean;
function Upcaseall(s : string):string;
function SetPCSystemTime(tDati: TDateTime): Boolean;
Procedure replace(var x1,x2 : real);  overload;
Procedure replace(var x1,x2 : integer);  overload;
Procedure replace(var x1,x2 : string);  overload;
Procedure replace(var x1,x2 : Tbitmap);  overload;
Procedure replace(var x1,x2 : Ticon);  overload;
function  DownCase( ch : Char ) : Char;
function NormalizeCase(Text : String) : String;
procedure CreateLink(const PathObj, PathLink, Desc, Param: string);
procedure Delay(msecs : Longint);
procedure hidefromALTTAB(formhandle : HWND);
procedure CanvasSetAngle(C: TCanvas; A: Single);
function booltoint(s : string):integer;
function integertobool(i : integer):string;
function max(a,b : real) : real; overload
Function min(a,b : real) : real; overload
Function min(a,b : integer) : integer; overload
function max(a,b : integer) : integer; overload
function CreateRGNFromImage(Image: TBitmap): HRGN;
function getdirectorysize(folder : string) : integer;  forward;
procedure directorycopy(startdirectory, movedirectory : string;OnProgress : TCopyingProgress);  forward;
function updatesize(startdirectory, movedirectory : string) : integer;  forward;
procedure updatecopy(startdirectory, movedirectory : string;OnProgress : TCopyingProgress); forward;
procedure createdirA(dir : string);
function rUpcase( ch : Char ) : Char;
function rDowncase( ch : Char ) : Char;
procedure savebitmap24bittofile(filename : string; bitmap : Tbitmap);
function loadbitmap24bitfromfile(filename : string) : TBitmap;

implementation

{ Tcopyfiles }

procedure Tcopyfile.copy(NameIn, NameOut: string);
const
  BufferSize = 3*4*4096;
Type
  PBuffer = ^TBuffer;
  TBuffer = array [1..BufferSize] of Byte;
var
  Size             : integer;
  Buffer           : PBuffer;
  infile, outfile  : File;
  SizeDone,SizeFile: Longint;
begin
  Fstop := false;
  Fnamein := NameIn;
  FnameOut := NameOut;
  if (NameIn <> NameOut) then
  begin
   buffer := Nil;
   AssignFile(infile, NameIn);
   System.Reset(infile, 1);
   try
     SizeFile := FileSize(infile);
     AssignFile(outfile, NameOut);
     System.Rewrite(outfile, 1);
     try
       SizeDone := 0; New(Buffer);
       repeat
       If Fstop then break;
         BlockRead(infile, Buffer^, BufferSize, Size);
         Inc(SizeDone, Size);
         If Assigned(FOnCall) then FOnCall(SizeDone, SizeFile);
         BlockWrite(outfile,Buffer^, Size);
         Application.processmessages;
       until Size < BufferSize;
       FileSetDate(TFileRec(outfile).Handle,
         FileGetDate(TFileRec(infile).Handle));
     finally
      if Buffer <> Nil then Dispose(Buffer);
      System.close(outfile)
     end;
   finally
     System.close(infile);
   end;
 end else
  Raise EInOutError.Create('File cannot be copied into itself');
end;

constructor Tcopyfile.create;
begin
 Fstop := True;
end;

procedure Tcopyfile.setoncall(const Value: TCallBack);
begin
  FOnCall := Value;
end;

procedure Tcopyfile.stop;
begin
  FStop := True;
end;

{Others Functions}

function GetCPUSpeed: real;
const
  DelayTime = 100; // measure time in ms
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Result := TimerLo / (1000.0 * DelayTime);
end;

function GetCPUSpeed(interval:integer):real;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(interval);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Result := TimerLo / (1000.0 * interval);
end;

function BitmapToRegion(Bitmap: TBitmap; TransColor: TColor): HRGN;
var
X, Y: Integer;
XStart: Integer;
begin
Result := 0;
with Bitmap do
for Y := 0 to Height - 1 do
begin
X := 0;
while X < Width do
begin
//   
while (X < Width) and (Canvas.Pixels[X, Y] = TransColor) do
Inc(X);
if X >= Width then
Break;
XStart := X;
while (X < Width) and (Canvas.Pixels[X, Y] <> TransColor) do
Inc(X);
if Result = 0 then
Result := CreateRectRgn(XStart, Y, X, Y + 1)
else
CombineRgn(Result, Result,
CreateRectRgn(XStart, Y, X, Y + 1), RGN_OR);
end;
end;
end;

Function hextointdef(hex:string;default:integer):integer;
var s:string;
int,i:integer;
begin
int:=0;
If length(hex)>0 then If hex[1]='$' then delete(hex,1,1);
If length(hex)>0 then begin
For i:=1 to length(hex) do begin
s:=s+' ';
s[i]:=hex[length(hex)+1-i];
end;
For i:=1 to length(hex) do
Case Upcase(s[i]) of
'0': int:=int;
'1': int:=int+round(intpower(16,i-1));
'2': int:=int+2*round(intpower(16,i-1));
'3': int:=int+3*round(intpower(16,i-1));
'4': int:=int+4*round(intpower(16,i-1));
'5': int:=int+5*round(intpower(16,i-1));
'6': int:=int+6*round(intpower(16,i-1));
'7': int:=int+7*round(intpower(16,i-1));
'8': int:=int+8*round(intpower(16,i-1));
'9': int:=int+9*round(intpower(16,i-1));
'A': int:=int+10*round(intpower(16,i-1));
'B': int:=int+11*round(intpower(16,i-1));
'C': int:=int+12*round(intpower(16,i-1));
'D': int:=int+13*round(intpower(16,i-1));
'E': int:=int+14*round(intpower(16,i-1));
'F': int:=int+15*round(intpower(16,i-1));
else begin int:=default; break; end;
end;
end else int:=default;
result:=int;
end;

function IntPower(Base: Extended; Exponent: Integer): Extended;
asm
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;

function SetFullscreenMode(Width,Height,PixelFormat:integer):Boolean;
var DeviceMode : TDevMode;
begin
 with DeviceMode do begin
  dmSize:=SizeOf(DeviceMode);
  dmBitsPerPel:=PixelFormat;
  dmPelsWidth:=Width;
  dmPelsHeight:=Height;
  dmFields:=DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT;
  result:=False;
  if ChangeDisplaySettings(DeviceMode,CDS_TEST or CDS_FULLSCREEN) <> DISP_CHANGE_SUCCESSFUL
   then Exit;
  Result:=ChangeDisplaySettings(DeviceMode,CDS_FULLSCREEN) = DISP_CHANGE_SUCCESSFUL;
 end;
end;

procedure RestoreDefaultMode;
var T : TDevMode;// absolute 0;
begin
 ChangeDisplaySettings(T,CDS_FULLSCREEN);
end;

function FileCopy(InFile,OutFile: String):boolean;
 var
    InFS,OutFS: TFileStream;
  begin
  try
    InFS  := TFileStream.Create( InFile,  fmOpenRead );
    OutFS := TFileStream.Create( OutFile, fmCreate   );
    InFS.Seek( 0, soFromBeginning );
    OutFS.CopyFrom( InFS, 0 );
    InFS.Free;
    OutFS.Free;
    result:=true;
    except
    result:=false;
    end;
  end;

function dircopy(startcatalog,movecatalog:string):boolean;
var
  OpStruc: TSHFileOpStruct;
  frombuf, tobuf: Array [0..128] of Char;
Begin
try
 FillChar( frombuf, Sizeof(frombuf), 0 );
 FillChar( tobuf, Sizeof(tobuf), 0 );
 StrPCopy( frombuf, startcatalog );
 StrPCopy( tobuf, movecatalog );
 With OpStruc DO Begin
  wFunc:= FO_COPY;
  pFrom:= @frombuf;
  pTo:=@tobuf;
  fFlags:= FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION;
  fAnyOperationsAborted:= False;
  hNameMappings:= Nil;
  lpszProgressTitle:= Nil;
 end;
 ShFileOperation( OpStruc );
 result:=true;
 except
 result:=false;
 end;
end;

procedure SetWallpaper(sWallpaperBMPPath : String; tupe : integer );
var
  reg : TRegIniFile;
begin
  reg := TRegIniFile.Create('Control Panel\Desktop' );
  with reg do begin
    WriteString( '', 'Wallpaper',
      sWallpaperBMPPath );
    Case tupe of
   0: WriteString('', 'TileWallpaper', '0' );
   1: WriteString('', 'TileWallpaper', '1' );
   2: WriteString('', 'TileWallpaper', '2' );
    end;
  end;
  reg.Free;
end;

function run(exefile:string):boolean;
var
  si : Tstartupinfo;
  p  : Tprocessinformation;
begin
 FillChar( Si, SizeOf( Si ) , 0 );
 with Si do begin
  cb := SizeOf( Si);
  dwFlags := startf_UseShowWindow;
  wShowWindow := 4;
 end;
 If Createprocess(nil,Pchar(exefile),nil,nil,false,Create_default_error_mode,nil,pchar(getdirectory(exefile)),si,p) then result:=true else result:=false;
end;

function runWait(exefile:string):boolean;
var
  si : Tstartupinfo;
  p  : Tprocessinformation;
begin
 FillChar( Si, SizeOf( Si ) , 0 );
 with Si do begin
  cb := SizeOf( Si);
  dwFlags := startf_UseShowWindow;
  wShowWindow := 4;
 end;
 If Createprocess(nil,pchar(exefile),nil,nil,false,Create_default_error_mode,nil,pchar(getdirectory(exefile)),si,p) then result:=true else result:=false;
 Waitforsingleobject(p.hProcess,infinite);
end;

procedure keyEng;
begin
LoadKeyboardLayout('00000409', KLF_ACTIVATE);
end;

procedure keyRus;
begin
LoadKeyboardLayout('00000419', KLF_ACTIVATE);
end;

function DriveState(DrvLetter: Char): integer;
var
  Mask: String[6];
  SearchRec: TSearchRec;
  oldMode: Cardinal;
  ReturnCode: Integer;
begin
  oldMode:= SetErrorMode(SEM_FAILCRITICALERRORS);
  Mask:= '?:\*.*';
  Mask[1] := DrvLetter;
  {$I-}  {     }
  ReturnCode := FindFirst(Mask, faAnyfile, SearchRec);
  FindClose(SearchRec);
  {$I+}
{0      

-18       

-21, -3 DS_NO_DISK  DOS, ERROR_NOT_READY  WinNT,
    ERROR_PATH_NOT_FOUND  Win 3.1

else          }

    Result := ReturnCode;
  SetErrorMode(oldMode);
end; 

procedure openCD;
begin
mciSendString('Set cdaudio door open wait',nil,0,0);
end;

procedure CloseCD;
begin
mciSendString('Set cdaudio door closed wait',nil,0,0);
end;

procedure RunOnStartup(Name:string;path:string;options:integer);
var
  sKey : string;
  reg  : TRegIniFile;
begin
  if options=0 then sKey := 'Once';
  if abs(options)=1 then sKey := '';
  reg := TRegIniFile.Create( '' );
  reg.RootKey := HKEY_CURRENT_USER;
  reg.WriteString(
    'Software\Microsoft'
    + '\Windows\CurrentVersion\Run'
    + sKey + #0,
    name,
    path );
  if options=-1 then
  reg.deletekey('Software\Microsoft'
    + '\Windows\CurrentVersion\Run'
    + #0, name);
    reg.closekey;
  reg.Free;
end;

function Autorunexe(disk:string):string;
var file1:textfile;
a,en:boolean;
e,name,str:string;
i,no:integer;
begin
no:=0;
en:=false;
If drivestate(char(disk[1]))<>21 then begin
If fileexists(disk+':\autorun.inf') then begin
try
Assignfile(file1,disk+':\autorun.inf');
reset(file1);
en:=true;
except
en:=false;
end;
end;
 If en then begin
 try
While not EoF(file1) do begin
readln(file1,str);
e:=e+str+#13;
end;
 except
 end;
closefile(file1);
str:=e;
For i:=1 to length(str)-3 do
If ((str[i]='o') or (str[i]='O')) and ((str[i+1]='p') or (str[i+1]='P')) and((str[i+2]='e') or (str[i+2]='E')) and((str[i+3]='n') or (str[i+3]='N')) and (str[i+4]='=') then
no:=i+4;
i:=0;
a:=false;
While not a do begin
i:=i+1;
name:=name+str[no+i];
If str[i+no+1]=#13 then a:=true;
end;
end;
end;
If en then result:=disk+':\'+name else result:='';
end;

function Autorunico(disk:string):string;
var file1:textfile;
a,en:boolean;
e,icon,str:string;
i,noic:integer;
begin
noic:=0;
en:=false;
If drivestate(char(disk[1]))<>21 then begin
If fileexists(disk+':\autorun.inf') then begin
try
Assignfile(file1,disk+':\autorun.inf');
reset(file1);
en:=true;
except
en:=false;
end;
end;
 If en then begin
While not EoF(file1) do begin
readln(file1,str);
e:=e+str+#13;
end;
closefile(file1);
str:=e;
For i:=1 to length(str)-3 do
If ((str[i]='i') or (str[i]='I')) and ((str[i+1]='c') or (str[i+1]='C')) and((str[i+2]='o') or (str[i+2]='O')) and((str[i+3]='n') or (str[i+3]='N')) and (str[i+4]='=') then
noic:=i+4;
i:=0;
a:=false;
While not a do begin
i:=i+1;
icon:=icon+str[noic+i];
If str[i+noic+1]=#13 then a:=true;
end;
end;
end;
If en then result:=disk+':\'+icon else result:='';
end;

function icontobit16(icon:Ticon):Tbitmap;
var b,bit:tbitmap;
ic:Ticon;
i,j:integer;
begin
ic:=ticon.create;
ic.Assign(icon);
try
b:=tbitmap.create;
bit:=tbitmap.create;
b.width:=ic.width;
b.height:=ic.height;
bit.width:=16;
bit.height:=16;
b.canvas.brush.color:=clmenu;
b.canvas.FillRect(rect(0,0,b.width,b.height));
b.canvas.draw(0,0,ic);
For i:=0 to b.width do
For j:=0 to b.height do begin
bit.canvas.Pixels[round(i/(b.width/bit.width)),round(j/(b.height/bit.height))]:=b.Canvas.Pixels[i,j];
end;
result:=bit;
except
result:=nil;
end;
ic.Free;
end;

function getdirectory(filename:string):string;
var i,n:integer;
begin
 n:=0;
 for i:=length(filename) downto 1 do
 If filename[i]='\' then
 begin
  n:=i;
  break;
 end;
 delete(filename,n,length(filename)-n+1);
 result:=filename;
end;

function getanyCDletter:string;
var i:integer;
begin
 result:='';
 for i:=ord('D') to ord('Z') do
 If GetDriveType(pchar(Chr(i)+':\'))=5 then
 begin
  result:=Chr(i);
  break;
 end;
end;

function getwinversion;
var reg:Tregistry;
result1,result2:string;
begin
reg:=tregistry.create;
reg.rootkey:=hkey_local_machine;
reg.openkey('\SOFTWARE\Microsoft\Windows\CurrentVersion',true);
result1:=reg.ReadString('ProductName');
reg.CloseKey;
reg.free;
reg:=tregistry.create;
reg.rootkey:=HKEY_LOCAL_MACHINE;
reg.openkey('\SOFTWARE\Microsoft\Windows NT\CurrentVersion\',true);
result2:=reg.ReadString('ProductName');
reg.CloseKey;
reg.free;
If result1<>'' then result:=result1 else result:=result2;
If result='' then result:='Uncnown';
end;

function getsystemroot;
var reg:Tregistry;
result1,result2:string;
begin
reg:=tregistry.create;
reg.rootkey:=hkey_local_machine;
reg.openkey('\SOFTWARE\Microsoft\Windows\CurrentVersion',true);
result1:=reg.ReadString('SystemRoot');
reg.CloseKey;
reg.free;
reg:=tregistry.create;
reg.rootkey:=HKEY_LOCAL_MACHINE;
reg.openkey('\SOFTWARE\Microsoft\Windows NT\CurrentVersion\',true);
result2:=reg.ReadString('SystemRoot');
reg.CloseKey;
reg.free;
If result1<>'' then result:=result1 else result:=result2;
end;

function getwinowner;
var reg:Tregistry;
result1,result2:string;
begin
reg:=tregistry.create;
reg.rootkey:=hkey_local_machine;
reg.openkey('\SOFTWARE\Microsoft\Windows\CurrentVersion',true);
result1:=reg.ReadString('RegisteredOwner');
reg.CloseKey;
reg.free;
reg:=tregistry.create;
reg.rootkey:=HKEY_LOCAL_MACHINE;
reg.openkey('\SOFTWARE\Microsoft\Windows NT\CurrentVersion\',true);
result2:=reg.ReadString('RegisteredOwner');
reg.CloseKey;
reg.free;
If result1<>'' then result:=result1 else result:=result2;
If result='' then result:='Uncnown';
end;

function getorganization;
var reg:Tregistry;
result1,result2:string;
begin
reg:=tregistry.create;
reg.rootkey:=hkey_local_machine;
reg.openkey('\SOFTWARE\Microsoft\Windows\CurrentVersion',true);
result1:=reg.ReadString('RegisteredOrganization');
reg.CloseKey;
reg.free;
reg:=tregistry.create;
reg.rootkey:=HKEY_LOCAL_MACHINE;
reg.openkey('\SOFTWARE\Microsoft\Windows NT\CurrentVersion\',true);
result2:=reg.ReadString('RegisteredOrganization');
reg.CloseKey;
reg.free;
If result1<>'' then result:=result1 else result:=result2;
If result='' then result:='Uncnown';
end;

procedure del_close_btn(handle:Thandle);
 var  hMenuHandle : HMENU;
begin
 if (Handle <> 0) then
 begin
  hMenuHandle := GetSystemMenu(Handle, FALSE);
  if (hMenuHandle <> 0) then
  DeleteMenu(hMenuHandle, SC_CLOSE, MF_BYCOMMAND);
 end;
end;

Procedure deldir(dir : String; mask : string);
Var
 Found  : integer;
 SearchRec : TSearchRec;
 f:textfile;
begin
  If length(dir)<4 then exit;
  If dir[length(dir)]<>'\' then dir:=dir+'\';
  ChDir(Dir);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(dir+SearchRec.Name) and extinmask(mask,getext(dir+SearchRec.Name)) then begin
  try
  Filesetattr(dir+SearchRec.Name,0);
  Assign(f,dir+SearchRec.Name);
  erase(f);
  except;
  end;
  end else If directoryexists(dir+SearchRec.Name) then deldir(dir+SearchRec.Name, mask);
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  try
  RmDir(Dir);
  except
  end;
end;

procedure dontruntwo(name : string);
var  hSemaphore:thandle;
begin
  hSemaphore := CreateSemaphore( nil, 0, 1, pchar(name) );
 IF ((hSemaphore <> 0) and (GetLastError = ERROR_ALREADY_EXISTS)) THEN
 BEGIN
  CloseHandle(hSemaphore);
  Halt;
 end;
end;

function loadiconfromexe( filename : string ; index : Integer): Hicon;
begin
result:=extracticon(0,filename,Index);
end;

Function GetDriveSerialNo(DriveLetter : string):Dword;
var
VolumeName,
FileSystemName     : array [0..MAX_PATH-1] of Char;
VolumeSerialNo     : DWord;
MaxComponentLength:cardinal;
FileSystemFlags: cardinal;
begin
GetVolumeInformation(
pchar(driveletter[1]+':\'),
VolumeName,
MAX_PATH,
@VolumeSerialNo,
MaxComponentLength,
FileSystemFlags,
FileSystemName,
MAX_PATH);
result:=VolumeSerialNo;
end;

Function getdrivename(driveletter : string):string;
var
VolumeName,
FileSystemName     : array [0..MAX_PATH-1] of Char;
VolumeSerialNo     : DWord;
MaxComponentLength:cardinal;
FileSystemFlags: cardinal;
begin
GetVolumeInformation(
pchar(driveletter[1]+':\'),
VolumeName,
MAX_PATH,
@VolumeSerialNo,
MaxComponentLength,
FileSystemFlags,
FileSystemName,
MAX_PATH);
result:=VolumeName;
end;

Procedure hidefromTaskBar(handle:Thandle);
var
 ExtendedStyle : integer;
begin
  ExtendedStyle:=GetWindowLong(application.Handle, GWL_EXSTYLE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE,
  WS_EX_TOOLWINDOW+ws_ex_topmost+ws_ex_ltrreading+ws_ex_left or ExtendedStyle);
end;

procedure hidetray(visi:boolean);
  Var 
    Tray, Child : hWnd; 
    C : Array[0..127] of Char; 
    S : String; 

  Begin
    Tray := FindWindow('Shell_TrayWnd', NIL);
    Child := GetWindow(Tray, GW_CHILD);
    While Child <> 0
          do Begin
               If GetClassName(Child, C, SizeOf(C)) > 0
                  Then Begin
                         S := StrPAS(C);
                         If UpperCase(S) = 'TRAYNOTIFYWND'
                            then begin

                                   If Visi
                                      then ShowWindow(Child, 1)
                                      else ShowWindow(Child, 0);
                                 end;
                       End; 
               Child := GetWindow(Child, GW_HWNDNEXT);
             End;
  End; 

Function strtofloatdef(str : string; default :real): real;
begin
try
result:=strtofloat(str);
except
result:=default;
end;
end;

Function getext(Filename : string) : string;
var i,j:integer;
s:string;
begin
j:=0;
For i:=length(filename) downto 1 do
If filename[i]='.' then
begin
j:=i;
break;
end;
s:='?';
If j<>0 then
begin
s:=copy(filename,j+1,length(filename)-j);
For i:=1 to length(s) do
s[i]:=Upcase(s[i]);
end;
result:=s;
end;

function RandomPwd(PWLen: integer; StrTable : string): string;
var
   Y,i: integer;
begin
  randomize;
  SetLength(result, PWLen);
  Y := Length(StrTable);
  for i:=1 to PWLen do
  begin
    result[i]:=StrTable[random(y)+1];
  end;
end;

function bitmaptoicon(bit : Tbitmap; color : Tcolor):Ticon;
var
        AndMask : TBitmap;
        IconInfo : TIconInfo;
        i,j:integer;
begin
AndMask := TBitmap.Create;
AndMask.Monochrome := true;
AndMask.width:=bit.width;
AndMask.height:=bit.height;
AndMask.Canvas.Brush.Color := clWhite;
AndMask.Canvas.FillRect(Rect(0, 0, bit.width, bit.height));
for j:=1 to bit.width do
for i:=1 to bit.height do
If bit.canvas.pixels[j,i]<>color then AndMask.Canvas.pixels[j,i]:=clblack;
result := TIcon.Create;
IconInfo.fIcon := true;
IconInfo.xHotspot := 0;
IconInfo.yHotspot := 0;
IconInfo.hbmMask := AndMask.Handle;
IconInfo.hbmColor := bit.Handle;
result.Handle := CreateIconIndirect(IconInfo);
AndMask.free;
end;

function extinmask(mask : string; ext : string):boolean;
var i,j:integer;
begin
result:=false;
If mask='||' then
begin
result:=true;
exit;
end;
for i:=1 to length(mask) do
if mask[i]='|' then
for j:=i to length(mask) do
begin
If mask[j]='|' then
if upcaseall(copy(mask,i+1,j-i-1))=upcaseall(ext) then
begin
result:=true;
end;
end;
end;

function Upcaseall(s : string):string;
var i : integer;
begin
result:=s;
for i:=1 to length(s) do
result[i]:=Upcase(result[i]);
end;

function SetPCSystemTime(tDati: TDateTime): Boolean;
var
   tSetDati: TDateTime;
   vDatiBias: Variant;
   tTZI: TTimeZoneInformation;
   tST: TSystemTime;
begin
   GetTimeZoneInformation(tTZI);
   vDatiBias := tTZI.Bias / (60*24);
   tSetDati := tDati + vDatiBias;
   with tST do
   begin
        wYear := StrToInt(FormatDateTime('yyyy', tSetDati));
        wMonth := StrToInt(FormatDateTime('mm', tSetDati));
        wDay := StrToInt(FormatDateTime('dd', tSetDati));
        wHour := StrToInt(FormatDateTime('hh', tSetDati))-1;
        wMinute := StrToInt(FormatDateTime('nn', tSetDati));
        wSecond := StrToInt(FormatDateTime('ss', tSetDati));
        wMilliseconds := 0;
   end;
   SetPCSystemTime := SetSystemTime(tST);
end;

Procedure replace(var x1,x2 : real);
var temp : real;
begin
temp:=x1;
x1:=x2;
x2:=temp;
end;

Procedure replace(var x1,x2 : integer);
var temp : integer;
begin
temp:=x1;
x1:=x2;
x2:=temp;
end;

Procedure replace(var x1,x2 : string);
var temp : string;
begin
temp:=x1;
x1:=x2;
x2:=temp;
end;

Procedure replace(var x1,x2 : Tbitmap);
var temp : Tbitmap;
begin
temp:=TBitmap.create;
temp:=x1;
x1:=x2;
x2.assign(temp);
temp.free;
end;

Procedure replace(var x1,x2 : Ticon);
var temp : Ticon;
begin
temp:=Ticon.create;
temp:=x1;
x1:=x2;
x2.assign(temp);
temp.free;
end;

function        DownCase( ch : Char ) : Char;
asm
{ ->    AL      Character       }
{ <-    AL      Result          }

        CMP     AL,'A'
        JB      @@exit
        CMP     AL,'Z'
        JA      @@exit
        SUB     AL,'A' - 'a'
@@exit:
end;

function NormalizeCase(Text : String) : String;
var i,n,z : integer;
s:string;
c:char;
begin
 n:=1;
 s:=text;
 If length(text)>1 then
 for i:=1 to length(text) do
 begin
  If (text[i]=' ') or (i=length(text)) then
  begin
   for z:=n to i do
   begin
    If z=n then c:=Upcase(text[z]) else c:=Downcase(text[z]);
    s[z]:=c;
   end;
   n:=i+1;
  end;
 end;
 Result:=s;
end;

procedure CreateLink(const PathObj, PathLink, Desc, Param: string);
  var
    IObject: IUnknown;
    SLink: IShellLink;
    PFile: IPersistFile;
  begin
    IObject := CreateComObject(CLSID_ShellLink);
    SLink := IObject as IShellLink;
    PFile := IObject as IPersistFile;
    with SLink do begin
      SetArguments(PChar(Param));
      SetDescription(PChar(Desc));
      SetPath(PChar(PathObj));
    end;
    PFile.Save(PWChar(WideString(PathLink)), FALSE);
  end;

procedure Delay(msecs : Longint);
var
  FirstTick : longint;
begin
  FirstTick:=GetTickCount;
  repeat
    Application.ProcessMessages; {    "" Windows}
  until (GetTickCount-FirstTick) >= msecs;
end;

procedure hidefromALTTAB(formhandle : HWND);
begin
  SetWindowLong(formHandle, GWL_EXSTYLE, ws_popup+ws_visible+ws_clipsiblings+ws_clipchildren+ws_overlapped);
end;

procedure CanvasSetAngle(C: TCanvas; A: Single);
var
  LogRec: TLOGFONT;     {Font informationen}
begin
  GetObject(C.Font.Handle,SizeOf(LogRec),Addr(LogRec));
  LogRec.lfEscapement := Trunc(A*10);
  C.Font.Handle := CreateFontIndirect(LogRec);
end;

function booltoint(s : string):integer;
var i:integer;
begin
result:=0;
for i:=length(s) downto 1 do
result:=result+round(strtoint(s[i])*intpower(2,length(s)-i));
end;

function integertobool(i : integer):string;
var j,temp:integer;
begin
temp:=i;
result:='';
for j:=1 to i div 2+1 do
begin
result:=inttostr(temp mod 2)+result;
temp:=temp div 2;
if temp=0 then break;
end;
end;

function max(a,b : real) : real;
begin
If a>b then result:=a else result:=b;
end;

Function min(a,b : real) : real;
begin
If a<b then result:=a else result:=b;
end;

Function max(a,b : integer) : integer;
begin
If a>b then result:=a else result:=b;
end;

function min(a,b : integer) : integer;
begin
If a<b then result:=a else result:=b;
end;

function TripleEqual(const t1,t2: TRGBTriple): Boolean;
begin  //   RGB-
 Result := (t1.rgbtBlue  = t2.rgbtBlue  ) and
           (t1.rgbtGreen = t2.rgbtGreen ) and
           (t1.rgbtRed   = t2.rgbtRed   )
end;


function CreateRGNFromImage(Image: TBitmap): HRGN;
Var
  X1,X,Y: Integer;        // 
  Sl: PRGBArray;          //     
  BlankColor: TRGBTriple; // ,   
begin
  X1 := -1;
  Result := CreateRectRgn(0,0,0,0);

  if (Image.Width>0) and (Image.Height>0) then
    begin
     SL := Image.ScanLine[0];
     BlankColor:= SL^[0];
    end;

  for y:=0 to Pred(Image.Height) do
    begin
     SL:=Image.ScanLine[y];
     for x:=0 to Pred(Image.Width) do
      if TripleEqual(SL^[x], BlankColor) then
        begin
         if x1>-1 then //     
           begin
             CombineRgn(Result,Result,CreateRectRgn(X1,Y,X,Y+1),RGN_OR);
             X1 := -1;
           end;
        end
      else //    
        begin if x1=-1 then x1:=x end
    end;
end;

function getdirectorysize(folder : string) : integer;
Var
 Found  : integer;
 SearchRec : TSearchRec;
 f:textfile;
begin
  result:=0;
  try
  If folder[length(folder)]<>'\' then folder:=folder+'\';
  ChDir(folder);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(folder+SearchRec.Name) then begin
  try
Application.ProcessMessages;
  Assign(f,folder+'\'+SearchRec.Name);
  reset(f);
  inc( result, filesize(f));
  closefile(f);
  except;
  end;
  end else If directoryexists(folder+SearchRec.Name) then result:=result+getdirectorysize(folder+'\'+SearchRec.Name );
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  except
  end;
end;

procedure directorycopy(startdirectory, movedirectory : string;OnProgress : TCopyingProgress);
Var
 Found  : integer;
 SearchRec : TSearchRec;
 f:textfile;
begin
  createdira(movedirectory);
  try
  If startdirectory[length(startdirectory)]<>'\' then startdirectory:=startdirectory+'\';
  ChDir(startdirectory);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(startdirectory+SearchRec.Name) then begin
  try
  filecopy( startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name);
  Application.ProcessMessages;
  assignfile(f,startdirectory+SearchRec.Name);
  reset(f);
  If assigned(OnProgress) then OnProgress(filesize(f));
  closefile(f);
  except;
  end;
  end else If directoryexists(startdirectory+SearchRec.Name) then directorycopy(startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name,onprogress);
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  except
  end;
end;

function updatesize(startdirectory, movedirectory : string) : integer;
Var
 Found , ft1,ft2 : integer;
 SearchRec : TSearchRec;
 f1,f2:textfile;
begin
 result:=0;
  try
  If startdirectory[length(startdirectory)]<>'\' then startdirectory:=startdirectory+'\';
  ChDir(startdirectory);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(startdirectory+SearchRec.Name) then begin
   try
   If fileexists(movedirectory+'\'+SearchRec.Name) then
   begin
    assignfile(f1,startdirectory+SearchRec.Name);
    assignfile(f2,movedirectory+'\'+SearchRec.Name);
    reset(f1);
    reset(f2);
    ft1:=fileage(startdirectory+SearchRec.Name);
    ft2:=fileage(movedirectory+'\'+SearchRec.Name);
    If (FileDateToDateTime(ft1)>FileDateToDateTime(ft2)) or (filesize(f1)>filesize(f2)) then
    inc(result,filesize(f1));
    close(f1);
    close(f2);

   end else begin
    assignfile(f1,startdirectory+SearchRec.Name);
    reset(f1);
    inc(result,filesize(f1));
    close(F1);
   end;
   Application.ProcessMessages;
   except
   end;
  end else If directoryexists(startdirectory+SearchRec.Name) then result:=result+updatesize(startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name);
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  except
  end;
end;

procedure updatecopy(startdirectory, movedirectory : string;OnProgress : TCopyingProgress);
Var
 Found , ft1,ft2 : integer;
 SearchRec : TSearchRec;
 f1,f2:textfile;
begin
  createdira(movedirectory);
  try
  If startdirectory[length(startdirectory)]<>'\' then startdirectory:=startdirectory+'\';
  ChDir(startdirectory);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(startdirectory+SearchRec.Name) then begin
   try
   If fileexists(movedirectory+'\'+SearchRec.Name) then
   begin
    assignfile(f1,startdirectory+SearchRec.Name);
    assignfile(f2,movedirectory+'\'+SearchRec.Name);
    reset(f1);
    reset(f2);
    ft1:=fileage(startdirectory+SearchRec.Name);
    ft2:=fileage(movedirectory+'\'+SearchRec.Name);
    If (FileDateToDateTime(ft1)>FileDateToDateTime(ft2)) or (filesize(f1)>filesize(f2)) then
  filecopy( startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name);

   
    close(f2);
    if assigned(onprogress) then onprogress(filesize(f1));
    close(f1);
   end else begin
   assignfile(f1,startdirectory+SearchRec.Name);
   reset(f1);
   ft1:=fileage(startdirectory+SearchRec.Name);
    if assigned(onprogress) then onprogress(filesize(f1));
    close(f1);
   filecopy( startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name);
   end;
   Application.ProcessMessages;
   except
   end;
  end else If directoryexists(startdirectory+SearchRec.Name) then updatecopy(startdirectory+SearchRec.Name, movedirectory+'\'+SearchRec.Name, onprogress);
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  except
  end;
end;

procedure createdirA(dir : string);
var i:integer;
begin
if length(dir)<3 then exit;
for i:=1 to length(dir) do
try
if (dir[i]='\') or (i=length(dir)) then createdir(copy(dir,1,i));
except
exit;
end;
end;

Procedure deldir(dir : String; mask : string; onprogress : TCopyingProgress);
Var
 Found,i  : integer;
 SearchRec : TSearchRec;
 f:file;
begin
  If length(dir)<4 then exit;
  try
  If dir[length(dir)]<>'\' then dir:=dir+'\';
  ChDir(Dir);
  Found := FindFirst('*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
   if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
   begin
  If fileexists(dir+SearchRec.Name) and extinmask(mask,getext(dir+SearchRec.Name)) then begin
  Filesetattr(dir+SearchRec.Name,0);
  Assignfile(f,dir+SearchRec.Name);
  try
  reset(f);
  i:=filesize(f);
  If assigned(onprogress) then onprogress(i);
  finally
  closefile(f);
  end;
  try
  erase(f);
  except;
  end;
  end else If directoryexists(dir+SearchRec.Name) then deldir(dir+SearchRec.Name, mask, onprogress);
   end;
    Found := sysutils.FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  try
  Filesetattr(dir,0);
  RmDir(Dir);
  except
  end;
  except
  end;
end;

function rUpcase( ch : Char ) : Char;
begin
result:=ch;
 if (ord(ch)<ord('')) and (ord(ch)>ord('')) then result:=chr(ord(ch)+ord('')-ord(''));
 if (ord(ch)<ord('z')) and (ord(ch)>ord('a')) then result:=chr(ord(ch)+ord('A')-ord('a'));
end;

function rDowncase( ch : Char ) : Char;
begin
result:=ch;
 if (ord(ch)<ord('')) and (ord(ch)>ord('')) then result:=chr(ord(ch)-ord('')+ord(''));
 if (ord(ch)<ord('Z')) and (ord(ch)>ord('A')) then result:=chr(ord(ch)-ord('A')+ord('a'));
end;

procedure savebitmap24bittofile(filename : string; bitmap : Tbitmap);
var f:file;
p:pargb;
buffer : Pbuffer;
h,w:integer;
h1,h2,h3,h4,w1,w2,w3,w4:byte;
i,j:integer;
begin
 h:=bitmap.Height;
 w:=bitmap.Width;
 buffer := Nil;
 new(buffer);
 asm
   mov al, byte ptr h
   mov h1,al
   mov eax,h
   shr eax,8
   mov h,eax
   mov al, byte ptr h
   mov h2,al
   mov eax,h
   shr eax,8
   mov h,eax
   mov al, byte ptr h
   mov h3,al
   mov eax,h
   shr eax,8
   mov h,eax
   mov al, byte ptr h
   mov h4,al
   mov al, byte ptr w
   mov w1,al
   mov eax,w
   shr eax,8
   mov w,eax
   mov al, byte ptr w
   mov w2,al
   mov eax,w
   shr eax,8
   mov w,eax
   mov al, byte ptr w
   mov w3,al
   mov eax,w
   shr eax,8
   mov w,eax
   mov al, byte ptr w
   mov w4,al
 end;
 buffer[1]:=h1;
 buffer[2]:=h2;
 buffer[3]:=h3;
 buffer[4]:=h4;
 buffer[5]:=w1;
 buffer[6]:=w2;
 buffer[7]:=w3;
 buffer[8]:=w4;
 assignfile(f,filename);
 System.Rewrite(f, 1);
 blockwrite(f,buffer^,8);
  h:=bitmap.Height;
 w:=bitmap.Width;
 bitmap.PixelFormat:=pf24bit;
 buffer:=nil;
 new(buffer);
 for i:=0 to h-1 do
 begin
  p:=bitmap.ScanLine[i];
 for j:=0 to w-1 do
 begin
  buffer[1]:=p[j].r;
  buffer[2]:=p[j].g;
  buffer[3]:=p[j].b;
 blockwrite(f,buffer^,3);
 end;
 end;
 System.close(f);
end;

function loadbitmap24bitfromfile(filename : string) : TBitmap;
var f:file;
p:pargb;
buffer : Pbuffer;
size,h,w:integer;
h1,h2,h3,h4,w1,w2,w3,w4:integer;
i,j,k:integer;
begin
    buffer := Nil;
   new(buffer);
   assignfile(f,filename);
   System.Reset(f, 1);
   blockread(f,buffer^,8,size);
 h1:=buffer[1];
 h2:=buffer[2];
 h3:=buffer[3];
 h4:=buffer[4];
 w1:=buffer[5];
 w2:=buffer[6];
 w3:=buffer[7];
 w4:=buffer[8];
 asm
  add eax,h4
  shl eax,8
  add eax,h3
  shl eax,8
  add eax,h2
  shl eax,8
  add eax,h1
  mov h,eax
  add eax,w4
  shl eax,8
  add eax,w3
  shl eax,8
  add eax,w2
  shl eax,8
  add eax,w1
  mov w,eax
 end;
Result:=Tbitmap.Create;
Result.pixelformat:=pf24bit;
Result.Width:=w;
Result.Height:=h;

   buffer := Nil;
   new(buffer);

for i:=0 to h-1 do
begin
p:=Result.ScanLine[i];
for j:=0 to w-1 do
begin
 blockread(f,buffer^,3,size);
 p[j].r:=buffer[1];
 p[j].g:=buffer[2];
 p[j].b:=buffer[3];
end;
end;
 system.close(f);
end;

end.
